#line 1 "C:/Users/Usuario/Documents/MikroC_programas/lm317_Controlled_by_MCP4161/lm317_Controlled_by_MCP4161.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 3 "C:/Users/Usuario/Documents/MikroC_programas/lm317_Controlled_by_MCP4161/lm317_Controlled_by_MCP4161.c"
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;
sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;

sbit DigPot_CS at RE2_bit;
sbit DigPot_CS_Direction at TRISE2_bit;

char volt=0, E0=1, E1=1, E2=1, E3=1;
char *text, txt[6], value=0;
unsigned int adc_rd;
short int aux=0;
float voltage;
short int scale=0;

void set_up() {

ANSEL = 0x04;
TRISA = 0x04;
ADCON1 = 0x82;
ANSELH = 0;
C1ON_bit = 0;
C2ON_bit = 0;
TRISB0_bit=1;
TRISB1_bit=1;
TRISE0_bit=1;
TRISE1_bit=1;
TRISC = 0x14;
ADC_Init();
DigPot_CS = 1;
DigPot_CS_Direction = 0;
SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV16, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
delay_us(100);
Lcd_Init();
Lcd_Cmd(_LCD_CURSOR_OFF);
Lcd_Cmd(_LCD_CLEAR);
text = "Voltage:";
Lcd_Out(1,1,text);
text = "Scale:";
Lcd_Out(2,4,text);
}
void Print() {

 unsigned char ch;
 voltage = adc_rd/10.240;
 voltage = voltage*0.25;
 FloatToStr(voltage, txt);
 Lcd_Out(1,9,txt);
 ch=scale;
 Lcd_Chr(2,10,48+ch);
}

 void main() {
 set_up();
 Delay_ms(100);
 do {
 adc_rd= ADC_Get_Sample(2);
 DigPot_CS = 0;
 SPI1_Write(0);
 SPI1_Write(value);

 SPI1_Write(0x20);
 SPI1_Write(value);
 DigPot_CS = 1;

 Print();

 if(scale==0) aux=0;
 if(scale==1) aux=1;
 if(scale==2) aux=3;
 if(scale==3) aux=5;
 if(scale==4) aux=15;
 if(scale==5) aux=17;
 if(scale==6) aux=51;
 if(scale==7) aux=85;
 if(scale==8) aux=127;

 if (Button(&PORTB,0,1,0)) E2=0;
 if (E2==0 && Button(&PORTB,0,1,1)){
 scale++;
 if (scale>8) scale=0;
 E2=1;
 }
 if (Button(&PORTB,1,1,0)) E3=0;
 if (E3==0 && Button(&PORTB,1,1,1)){
 scale--;
 if (scale<0) scale=8;
 E3=1;
 }
 if (Button(&PORTE,0,1,0)) E0=0;
 if (E0==0 && Button(&PORTE,0,1,1)){
 value = value+aux;
 if (value>255) value=0;
 E0=1;
 }
 if (Button(&PORTE,1,1,0)) E1=0;
 if (E1==0 && Button(&PORTE,1,1,1)){
 value = value-aux;
 if (value<0) value=255;
 E1=1;
 }

 } while (1);
}
