//linear power source controlled by PWM
char E0=1, E1=1, E2=1, E3=1;
int duty=0;
short int escala=8, divisor=0;
unsigned char display[9] = {0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F};
void set_up() {

ANSEL = 0;             // set the rest of pins as digital inputs or outputs.
ANSELH = 0;
C1ON_bit = 0;          // analog comparators off.
C2ON_bit = 0;
TRISC2_bit=0;          //RC2 was configured as digital output.
TRISA5_bit=1;          //RA5 was configured as digital intput.
TRISE0_bit=1;         // RE0 and RE1 were configured as digital input.
TRISE1_bit=1;
TRISE2_bit=1;
TRISB=0;
PORTB=0;
PWM1_Init(2000);     //Frequency 2KHz.
PWM1_Start();
}

void main() {
set_up();

while (1){

    if(escala==0) divisor=0;
    if(escala==1) divisor=1;
    if(escala==2) divisor=3;
    if(escala==3) divisor=5;
    if(escala==4) divisor=15;
    if(escala==5) divisor=17;
    if(escala==6) divisor=51;
    if(escala==7) divisor=85;
    if(escala==8) divisor=127;
    
    PORTB = display[escala];
    
   if (Button(&PORTE,2,1,0)) E2=0;      //if the button has been pushed
   if (E2==0 && Button(&PORTE,2,1,1)){  //and after that the button is free
       escala++;
   if (escala>8) escala=0;
       E2=1;
   }
   if (Button(&PORTA,5,1,0)) E3=0;      //if the button has been pushed
   if (E3==0 && Button(&PORTA,5,1,1)){  //and after that the button is free
       escala--;
   if (escala<0) escala=8;
       E3=1;
   }
   if (Button(&PORTE,0,1,0)) E0=0;      //if the button has been pushed
   if (E0==0 && Button(&PORTE,0,1,1)){  //and after that the button is free
       duty=duty+divisor;                         //increase temp1.
   if (duty>255) duty=255;
       E0=1;
   }
   if (Button(&PORTE,1,1,0)) E1=0;      //if the button has been pushed
   if (E1==0 && Button(&PORTE,1,1,1)){  //and after that the button is free
       duty=duty-divisor;               //increase temp1.
   if (duty<0) duty=0;
       E1=1;
   }
    PWM1_Set_Duty(duty);
    delay_ms(1);
  }
}